// -*- C++ -*-
// $Id: Time_Client_i.h 28943 1999-09-26 21:51:01Z schmidt $

// ============================================================================
//
// = LIBRARY
//    TAO/examples/Simple/time
//
// = FILENAME
//    Time_Client_i.h
//
// = DESCRIPTION
//    This class implements the client calls to the Time example.
//
// = AUTHOR
//   Balachandran Natarajan <bala@cs.wustl.edu>
//    
// ============================================================================

#ifndef TIME_CLIENT_I_H
#define TIME_CLIENT_I_H

#include "../Simple_util.h"
#include "TimeC.h"

class Time_Client_i
{
  // = TITLE
  //   Time_Client interface subclass.
  //
  // = DESCRIPTION
  //   This class implements the interface between the interface
  //   objects and the client.
public:
  // = Initialization and termination methods.
  Time_Client_i (void);
  // Constructor

  virtual ~Time_Client_i (void);
  // Destructor

  virtual int run (const char *,int, char** );
  // Execute the methods

private:
  Client<Time, Time_var> client;
  // Instantiate the client object.
};


#endif /* TIME_CLIENT_I_H */
